﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;
using System.ComponentModel;

namespace SilverlightApplication10
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();

			treeList.ItemContainerGenerator.StatusChanged += new EventHandler(ItemContainerGenerator_StatusChanged);

			treeList.ItemsSource = new ObservableCollection<Item>
			{
				new Item{Name="1"},
				new Item{Name="2"},
				new Item{Name="3"},
			};
		}

		void ItemContainerGenerator_StatusChanged(object sender, EventArgs e)
		{
			var container = treeList.ItemContainerGenerator.ContainerFromItem(treeList.SelectedItem) as RadTreeListViewItem;
			if (container != null)
			{
				container.IsSelected = true;

				//Check here if you want to put it in edit mode.
				container.IsInEditMode = true;
			}
		}

		int index = 2;

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			var item = new Item { Name = string.Format("{0}", index++) };
			(treeList.ItemsSource as IList<Item>).Add(item);
			treeList.SelectedItem = item;
		}
	}

	public class TempalteSelectorExample : DataTemplateSelector
	{
		public override DataTemplate SelectTemplate(object item, DependencyObject container)
		{
			var i = item as Item;
			if (i == null)
				return null;

			int value = -1;

			if (int.TryParse(i.Name, out value))
			{
				if (value % 2 == 0)
					return App.Current.Resources["textEdit"] as DataTemplate;
			}
			return App.Current.Resources["textNonEdit"] as DataTemplate;
		}
	}

	public class Item : INotifyPropertyChanged
	{
		private string name;

		public string Name
		{
			get { return name; }
			set
			{
				if (name != value)
				{
					name = value;
					OnPropertyChanged("Name");
				}
			}
		}

		private void OnPropertyChanged(string name)
		{
			if (PropertyChanged != null)
				PropertyChanged(this, new PropertyChangedEventArgs(name));
		}

		public event PropertyChangedEventHandler PropertyChanged;
	}
}
